Subject: Re: bug#44297: [Feature request] project.el: Additional utility functions

From: Brian Leung <[email-masked]>
Date: Fri, 30 Oct 2020 01:47:41 +0100 (CET)

> > project-find-file-in-directory: completing-read for a directory
within the project, and then within the selected directory,
completing-read for a file within that directory
>
> Is that one really a frequent operation?
>
> I would imagine that project-find-file, with fuzzy search, would be a
faster solution either way.

It's something that seems good on paper but that I always forget to
use (with Projectile). My rationale for its usefulness is that having
to visually filter similar file names based on directory can be a
mental burden sometimes when there are similarly-named files in different
directories. I don't feel too strongly about this, though, and could
live without this feature.

> > https://www.emacswiki.org/emacs/FindOtherFile
> >
> > Projectile also has a command with a similar name.
> >
> > The feature will be pretty C/C++-centric
>
> Not if it's customised via ff-other-file-alist or similar.

It's also useful with OCaml.

> > What I don't understand, is why should it be in the project- namespace? Looking
> > for a file with the same name in the current dir doesn't execute the notion of
> > the current project, even a little bit.
> >
> > Projectile does a project-wide search for a file with the same basename (but a
> > different extension). Is that actually useful?
>
> Maybe when e.g. headers and source files are in different directories?
> I don't know whether that's already supported by find-file.el.

I cannot figure out how to quickly retrieve the header with
ff-find-other-file when the source and header are in different
directories; it seems necessary to manually find the containing
directory with completing-read during the ff-find-other-file
execution, which is cumbersome. So I think this feature would make
sense in project.el.

> ----------------------------------------
> From: Basil L. Contovounesios <[email-masked]>
> Sent: Fri Oct 30 00:57:07 CET 2020
> To: Dmitry Gutov <[email-masked]>
> Cc: Juri Linkov <[email-masked]>, <[email-masked]>, <[email-masked]>
> Subject: Re: bug#44297: [Feature request] project.el: Additional utility functions
> 
> 
> Dmitry Gutov <[email-masked]> writes:
> 
> > On 29.10.2020 11:03, Juri Linkov wrote:
> >>> It would be nice if project.el had the following interactive functions:
> >>>
> >>> project-find-other-file: Find a file with the same basename as the current file but a different extension
> >> Maybe then it should be named project-find-other-extension?
> >> Otherwise, project-find-other-file might imply a similarity
> >> with find-alternate-file (C-x C-v).
> >
> > I think the term is pretty much established:
> > https://www.emacswiki.org/emacs/FindOtherFile
> >
> > Projectile also has a command with a similar name.
> >
> > The feature will be pretty C/C++-centric
> 
> Not if it's customised via ff-other-file-alist or similar.
> 
> > , but I suppose it's useful enough.
> 
> > What I don't understand, is why should it be in the project- namespace? Looking
> > for a file with the same name in the current dir doesn't execute the notion of
> > the current project, even a little bit.
> >
> > Projectile does a project-wide search for a file with the same basename (but a
> > different extension). Is that actually useful?
> 
> Maybe when e.g. headers and source files are in different directories?
> I don't know whether that's already supported by find-file.el.
> 
> -- 
> Basil

-- 
Sent with https://mailfence.com
Secure and private email